> {-# LANGUAGE UnicodeSyntax, UndecidableInstances #-}

> module CofreeComonad
> where

Cofree comonad of a functor.

> data Cofree f a = Root { extract :: a, branch :: f (Cofree f a) }
>
> instance (Show a, Show (f (Cofree f a))) => Show (Cofree f a) where
>   show (Root a x) = show a ++ "@" ++ show x
>
> trace :: (Functor f) => (b -> a) -> (b -> f b) -> (b -> Cofree f a)
> trace get next b =  Root (get b) (fmap (trace get next) (next b))

> delta :: (Functor f) => Cofree f a -> Cofree f (Cofree f a)
> delta t@(Root _a us) = Root t (fmap delta us)

> instance (Functor f) => Functor (Cofree f) where
>   fmap f (Root a ts) = Root (f a) (fmap (fmap f) ts)
