> {-# LANGUAGE UnicodeSyntax, UndecidableInstances #-}

> module Pointed
> where

Free pointed functor ([Var]iable and [Con]structor).

> data Pointed f a = Var a | Con (f a)
>
> instance (Functor f) => Functor (Pointed f) where
>  fmap f (Var x) = Var (f x)
>  fmap f (Con x) = Con (fmap f x)
>
> (\/) :: (a -> b) -> (f a -> b) -> (Pointed f a -> b)
> ( f \/ _g) (Var x) = f x
> (_f \/  g) (Con x) = g x

Converting between P-algebras and S-algebras.

> up :: (s a -> a) -> (Pointed s a -> a)
> up a = id \/ a
>
> down :: (Pointed s a -> a) -> (s a -> a)
> down a = a . Con
