> import InitialAlgebra
> import FinalCoalgebra

Syntax functor.

> data S a = One | Plus (a, a) | FBy (Integer, a)
>   deriving (Show)
>
> instance Functor S where
>  fmap _f One           = One
>  fmap  f (Plus (p, q)) = Plus (f p, f q)
>  fmap  f (FBy (a, p))  = FBy (a, f p)

> ex :: Mu S
> ex = In (Plus (In One, In One))

Behaviour functor.

> data B a = Cons (Integer, a)
>   deriving (Show)
>
> instance Functor B where
>   fmap f (Cons (n, s)) = Cons (n, f s)

Distributive law - aka stream equations.

> lambda :: S (B a) -> B (S a)
> lambda (One)                            = Cons (1, One)
> lambda (Plus (Cons (m, s), Cons(n, t))) = Cons (m + n, Plus (s, t))
> lambda (FBy (m, Cons (n, s)))           = Cons (m, FBy (n, s))

Liftings.

> colift :: (a -> B a) -> (S a -> B (S a))
> colift c = lambda . fmap c

> lift :: (S a -> a) -> (S (B a) -> B a)
> lift a = fmap a . lambda

Semantics (denotational and operational).

> dsem, osem :: Mu S -> Nu B
> dsem = fold   (unfold (colift out))
> osem = unfold (fold   (lift   In ))

We can define |one|

> one :: Nu B
> one = dsem (In One)

but we can't define the stream operator |plus|. To be able to do that
we need syntax with variables.