> import InitialAlgebra
> import FinalCoalgebra
> import Pointed

Syntax functor.

> data S a = One | Plus (a, a) | FBy (Integer, a) | Id a
>   deriving (Show)

NB. |FBy|, short for ``followed by'', embeds semantics into syntax.

> instance Functor S where
>  fmap _f One           = One
>  fmap  f (Plus (p, q)) = Plus (f p, f q)
>  fmap  f (FBy (a, p))  = FBy (a, f p)
>  fmap  f (Id p)        = Id (f p)

> ex :: Mu S
> ex = In (Plus (In One, In One))

Behaviour functor.

> data B a = Cons (Integer, a)
>   deriving (Show)
>
> instance Functor B where
>   fmap f (Cons (n, s)) = Cons (n, f s)

Stream equations.

> rho :: S (B a) -> B (Pointed S a)
> rho (One)                            = Cons (1, Con One)
> rho (Plus (Cons (m, s), Cons(n, t))) = Cons (m + n, Con (Plus (s, t)))
> rho (FBy (m, Cons (n, s)))           = Cons (m, Con (FBy (n, s)))
> rho (Id (Cons (m, s)))               = Cons (m, Var s) -- uses |Var|
> -- rho (Tail (Cons (m, s)))             = Cons (?? -- doesn't work

Distributive law.

> lambda :: Pointed S (B a) -> B (Pointed S a)
> lambda (Var x) = fmap Var x
> lambda (Con x) = rho x

> colift :: (a -> B a) -> (Pointed S a -> B (Pointed S a))
> colift c = lambda . fmap c

> lift :: (Pointed S a -> a) -> (Pointed S (B a) -> B a)
> lift a = fmap a . lambda

Semantics of closed terms (denotational and operational).

> dsem, osem :: Mu S -> Nu B
> dsem = fold   (down (unfold (colift out    )))
> osem = unfold (fold (down   (lift   (up In))))

Sigh. We still can't define the stream operator |plus| as we need
nested terms.