> {-# LANGUAGE NPlusKPatterns #-}
> module Tree
> where
> import Prelude hiding (map, repeat, unzip, zip)

> data Tree α = Node { root   :: α, left   :: Tree α, right  :: Tree α } {-"."-}

> repeat a  =  t where t = Node a t t
> zip g t u =  Node (g (root t) (root u)) (zip g (left t) (left u)) (zip g (right t) (right u))
> map f t =  Node (f (root t)) (map f (left t)) (map f (right t))
> unzip t  =   (map fst t, map snd t)


> depth  ::  Int
> depth  =   5

> showTree d t = putStr (showsTree d t "")

> showsTree d = showt d
>   where
>   showt 0 t        =  showString ""
>   showt (n + 1) t  =  showt n (left t) .
>                       showString (replicate (4 * (d - n - 1)) ' ') . shows (root t) . showString "\n" .
>                       showt n (right t)

> instance (Show a) => Show (Tree a) where
>    showsPrec _ t = showsTree depth t

> equal              ::  (Eq α) => Int -> Tree α -> Tree α -> Bool
> equal 0       t u  =   root t == root u
> equal (n + 1) t u  =   root t == root u && equal n (left  t) (left  u) 
>                                         && equal n (right t) (right u)

> instance (Eq a) => Eq (Tree a) where
>   t == u  =  equal depth t u  -- HACK
> instance (Ord a) => Ord (Tree a) where
>   t <= u  =  error "TODO"

> instance (Num α) => Num (Tree α) where
>   (+)          =  zip (+)
>   (-)          =  zip (-)
>   (*)          =  zip (*)
>   negate       =  map negate
>   fromInteger  =  repeat . fromInteger
>   abs          =  map abs
>   signum       =  map signum

> instance (Enum a) => Enum (Tree a) where
>   toEnum i    =  repeat (toEnum i)
>   fromEnum t  =  fromEnum (root t)      -- HACK?!

> instance (Real a) => Real (Tree a) where
>   toRational t  =  toRational (root t)  -- HACK?!

> instance (Integral α) => Integral (Tree α) where
>   div          =  zip div
>   mod          =  zip mod
>   quotRem s t  =  unzip (zip quotRem s t)
>   toInteger t  =  toInteger (root t)    -- HACK?!

> instance (Fractional α) => Fractional (Tree α) where
>   (/)          =  zip (/)
>   recip        =  map recip
>   fromRational =  repeat . fromRational
